from app_logging import AppLogger
import constants

from ByteOperations import ByteOperations


class DownMessageParser:
    countIndex = 16
    firstDownMessage = 18

    @staticmethod
    def process(response):
        log = AppLogger()
        """
        Takes a byte array from iMonnit and returns a list of commands for the Gateway to pass on.
        """
        DownMessages = []
        if not response:
            return DownMessages
        count = response[DownMessageParser.countIndex]
        if constants.VERBOSE_LOGS:
           log.info('Total DownMessages: {}'.format(count))
        nextStartIndex = DownMessageParser.firstDownMessage
        while count != 0:
            response = response[nextStartIndex:]
            length = response[1]
            # ByteOperations.indexPrint(response)
            nextStartIndex = length + 3
            downmessage = response[0:nextStartIndex]
            if constants.VERBOSE_LOGS:
                log.info('DownMessages: {}'.format(downmessage))
            DownMessages.append(downmessage)
            count -= 1
        return DownMessages
