class ByteOperations:

    @staticmethod
    def from_bytes(b):
        return int.from_bytes(b, byteorder='little', signed=False)

    @staticmethod
    def to_bytes(num, size):
        assert type(num) is int
        return [b for b in num.to_bytes(size, byteorder='little', signed=False)]

    @staticmethod
    def bytToStr(byt):
        return [hex(b) for b in byt]

    @staticmethod
    def intToHex(byt):
        return [hex(b) for b in byt]

    @staticmethod
    def index_print(byt):
        x = 0
        for b in byt:
            print(x, hex(b))
            x += 1

    @classmethod
    def add_to_bytes(cls, byt, num):
        length = len(byt)
        b = cls.from_bytes(byt)
        b += num
        byt = b.to_bytes(length, byteorder='little', signed=False)
        return byt
